'''
this is a part of the heybuddy project
copyright 2010 jezra lickter http://www.jezra.net
'''
from DentScroller import DentScroller
from DentButton import DentButton
import gtk,gobject
class UserPage(gtk.VBox,gobject.GObject):
	__gsignals__={
		'user-page-hide': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
						 ()
		),
		'follow-user' : (
			gobject.SIGNAL_RUN_FIRST,gobject.TYPE_NONE,
				(gobject.TYPE_STRING,gobject.TYPE_BOOLEAN)
			),
		'direct-clicked': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
							 (gobject.TYPE_STRING,)
			),
	}
	def __init__(self):
		gtk.VBox.__init__(self)
		gobject.GObject.__init__(self)
		self.set_homogeneous(False)
		self.toggle_enabled=True
		#we need a grip of labels
		self.name_label = gtk.Label()
		self.pack_start(self.name_label,False,False,0)
		
		self.description_label = gtk.Label()
		self.pack_start(self.description_label,False,False,0)
		self.description_label.set_line_wrap(True)
		
		self.location_label = gtk.Label()
		self.pack_start(self.location_label,False,False,0)
		
		#make an hbox to hold widgets
		widgetbox = gtk.HBox(False)
		self.pack_start(widgetbox,False,False,0)
		#make a checkbutton if we are following
		self.following_checkbutton = gtk.CheckButton("Following")
		self.following_checkbutton.connect('toggled', self.following_toggled)
		widgetbox.pack_start(self.following_checkbutton,False,False,0)
		#how about a 'direct' button?
		self.direct_button = DentButton('direct')
		self.direct_button.connect("clicked",self.direct_clicked)
		widgetbox.pack_start(self.direct_button,False,False,0)
		#create a user dent scroller and add it to the user page
		self.dentScroller = DentScroller()
		self.pack_start(self.dentScroller)
		
		#make a "close" button
		hbox = gtk.HBox(False)
		user_close_button=gtk.Button("Close")
		hbox.pack_start(user_close_button,False,False,0)
		user_close_button.connect("clicked",self.close)
		self.pack_end(hbox,False,False,0)
		
	def set_user_data(self,data):
		self.screen_name = data['screen_name']
		self.name_label.set_text("%s (%s)" %(data['name'],data['screen_name']) )
		if data['location']!=None:
			self.location_label.set_text("%s" %(data['location']) )
			self.location_label.show()
		else:
			self.location_label.hide()
			
		self.description_label.set_text("%s" %(data['description']) )
		if data['following']=="true":
			self.set_is_friend(True)
		#enable the stuff
		self.enable()
		
	def set_is_friend(self,bool):
		self.toggle_enabled=False
		self.is_friend=bool
		self.following_checkbutton.set_active( bool )
		self.toggle_enabled=True
		
	def following_toggled(self,widget):
		if self.toggle_enabled:
			self.new_is_friend = self.following_checkbutton.get_active()
			self.emit('follow-user',self.screen_name,self.new_is_friend)

	def clear(self):
		self.dentScroller.clear()
		#self.image.hide()
		
	def close(self,button):
		self.emit('user-page-hide')
		
	def direct_clicked(self,button):
		self.emit("direct-clicked",self.screen_name)
		
	def disable(self):
		self.following_checkbutton.set_sensitive(False)
		self.direct_button.set_sensitive(False)
	
	def enable(self):
		self.following_checkbutton.set_sensitive(True)
		self.direct_button.set_sensitive(True)
